<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- bootstrap link -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- link data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
    <title>Task 512.40</title>
</head>

<body>
    <div class="container">
        <div class="text-center">
            <h3>DANH SÁCH NGƯỜI DÙNG</h3>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
        </div>
        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="user-table">
                <thead class="bg-info">
                    <tr>
                        <th>STT</th>
                        <th>Fullname</th>
                        <th>Phone</th>
                        <th>Status</th>
                        <th>Action</th>
                    </tr>
                </thead>
            </table>
        </div>
        <!-- Add user modal -->
        <div>
            <div id="add-user-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Add new user</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="input-add-user-fullname">Full Name</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-add-user-fullname" name="UserFullname"
                                            placeholder="Fullname..." class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="input-add-user-phone">Phone</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-add-user-phone" name="Userphone"
                                            placeholder="phone..." class="form-control">
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="select-add-user-status">Status</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select class="form-control" name="Userstatus" id="select-add-user-status">
                                            <option value="Level 0">Level 0</option>
                                            <option value="Level 1">Level 1</option>
                                            <option value="Level 2">Level 2</option>
                                            <option value="Level 3">Level 3</option>
                                        </select>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-create-cancel"
                                data-dismiss="modal">Cancel</button>
                            <button class="btn btn-success" id="btn-confirm-add-user">Insert user</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Add user modal -->
        <div>
            <div id="update-user-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Update user</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="input-update-user-fullname">Full Name</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-update-user-fullname" name="UserFullname"
                                            placeholder="Fullname..." class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="input-update-user-phone">Phone</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-update-user-phone" name="Userphone"
                                            placeholder="phone..." class="form-control">
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="select-update-user-status">Status</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select class="form-control" name="Userstatus" id="select-update-user-status">
                                            <option value="Level 0">Level 0</option>
                                            <option value="Level 1">Level 1</option>
                                            <option value="Level 2">Level 2</option>
                                            <option value="Level 3">Level 3</option>
                                        </select>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                            <button class="btn btn-success" id="btn-confirm-update-user">Update user</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Delete confirm modal -->
        <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <label>Bạn có chắc chắn muốn xóa user này không?</label>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // link API
    const gBASE_URL = "http://localhost:8000/users/";

    const gTABLE_NAME_COL = ["stt", "fullName", "phone", "status", "action"]
    var gUserId = "";
    var gStt = 0;
    var gUserObj = {
        fullName: "",
        phone: "",
        status: ""
    }
    var gUserTable = $("#user-table").DataTable({
        paging: false,
        columns: [
            { data: gTABLE_NAME_COL[0] },
            { data: gTABLE_NAME_COL[1] },
            { data: gTABLE_NAME_COL[2] },
            { data: gTABLE_NAME_COL[3] },
            { data: gTABLE_NAME_COL[4] }
        ],
        columnDefs: [

            {
                targets: 0,
                render: function () {
                    return gSTT++;
                }
            },
            {
                targets: 4,
                defaultContent: ` <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                        <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                        `
            }

        ]
    })

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    //gán sự kiện cho nút Thêm user

    $(document).on("click", "#btn-add-user", function () {
        $("#add-user-modal").modal("show");
    });

    //gán sự kiện cho nút Insert user (trên modal):
    $("#add-user-modal").on("click", "#btn-confirm-add-user", function () {
        onBtnInsertUserClick(gUserObj)
    });

    //gán sự kiện cho nút Update user
    $("#user-table").on("click", ".edit-user", function () {
        gUserId = onBtnUpdateUserClick(this)
        // updateUserByUserId(gUserId)
        showUserDataIntoModalUpdate(gUserObj)

    });
    //gán sự kiện cho nút Update user (trên modal):
    $("#update-user-modal").on("click", "#btn-confirm-update-user", function () {
        console.log("ok")
        onBtnConfirmUpdateUserClick(gUserObj);
    });

    //gán sự kiện cho nút delete user trên table

    $("#user-table").on("click", ".delete-user", function () {
        console.log("alo")
        gUserId = onBtnDeleteUserClick(this)
        $("#delete-confirm-modal").modal("show");

    });
    //gán sự kiện cho nút Delete user (trên modal):
    $("#delete-confirm-modal").on("click", "#btn-confirm-delete-user", function () {
        onBtnConfirmDeleteUserClick()
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        getUserList();

    }
    //hàm ấn nút Insert User (trên modal):
    function onBtnInsertUserClick(paramUserObj) {
        readDataUser(paramUserObj);
        var vDataValid = validateUserData(paramUserObj);
        if (vDataValid) {
            callApiToAddNewUser(paramUserObj)
        }
    }

    //hàm ấn nút update user trong table:
    function onBtnUpdateUserClick(paramBtnUpdate) {
        var vTableRow = $(paramBtnUpdate).parents("tr");
        var vDataTableRow = gUserTable.row(vTableRow);
        var vUserIdObj = vDataTableRow.data()._id;
        gUserObj = vDataTableRow.data()
        return vUserIdObj

    }
    //hàm ấn nút update user (trên modal): 
    function onBtnConfirmUpdateUserClick() {
        readDataUpdateUser(gUserObj);
        var vDataUpdateValid = validateDataUpdateUser(gUserObj);
        if (vDataUpdateValid) {
            callApiToUpdateUserById(gUserObj)
        }
    }

    //hàm ấn nút delete user trên table:
    function onBtnDeleteUserClick(paramBtnDelete) {
        var vTableRow = $(paramBtnDelete).parents("tr");
        var vDataTableRow = gUserTable.row(vTableRow);
        var vUserIdObj = vDataTableRow.data()._id;
        return vUserIdObj
    }

    //hàm ấn nút update user (trên modal): 
    function onBtnConfirmDeleteUserClick() {
        console.log("xoa xoa")
        callApiToDeleteUserById(gUserId)

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm lấy danh sách user:
    function getUserList() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                loadUserListIntoTable(paramRes)
            },
            error: function (paramError) {
                console.log(paramError.responseText)
            }
        })
    };
    //hàm load user vào table
    function loadUserListIntoTable(paramUserList) {
        gSTT = 1;
        gUserTable.clear();
        gUserTable.rows.add(paramUserList.data);
        gUserTable.draw();
    }

    //hàm đọc dữ liệu user nhập vào("trên modal"):
    function readDataUser(paramUserObj) {
        paramUserObj.fullName = $.trim($("#input-add-user-fullname").val());
        paramUserObj.phone = $.trim($("#input-add-user-phone").val());
        paramUserObj.status = $.trim($("#select-add-user-status").val());
    }
    //hàm validate dữ liệu user nhập vào("trên modal"):
    function validateUserData(paramUserObj) {
        if (paramUserObj.fullName == "") {
            alert("Please input fullname");
            return false;
        }
        if (paramUserObj.phone == "") {
            alert("Please input phone");
            return false;
        }

        return true
    }
    //hàm gọi API để thêm user mới:
    function callApiToAddNewUser(paramUserObj) {
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramUserObj),
            success: function (paramRes) {
                handleInsertUserSuccess()
            },
            error: function (paramErorr) {
                console.log(paramErorr.responseText)
            }
        });
    }
    //hàm handle khi add user thành công:
    function handleInsertUserSuccess() {
        alert("Add user successfully");
        resertInsertUserForm();
        $("#add-user-modal").modal("hide");
        getUserList()
    }

    //hàm xóa trắng form insert user:
    function resertInsertUserForm() {
        $("#input-add-user-fullname").val("");
        $("#input-add-user-phone").val("");
        $("#input-add-user-status").val("0");
    }
    //hàm show user data into modal update:
    function showUserDataIntoModalUpdate(paramUserData) {
        $("#input-update-user-fullname").val(paramUserData.fullName);
        $("#input-update-user-phone").val(paramUserData.phone);
        $("#select-update-user-status").val(paramUserData.status);
        $("#update-user-modal").modal("show");
    }
    // Các hàm xử lý update user
    //hàm đọc dữ liệu update user nhập vào("trên modal"):
    function readDataUpdateUser(paramUserObj) {
        paramUserObj.fullName = $.trim($("#input-update-user-fullname").val());
        paramUserObj.phone = $.trim($("#input-update-user-phone").val());
        paramUserObj.status = $.trim($("#select-update-user-status").val());
    }
    //hàm validate dữ liệu update user nhập vào("trên modal"):
    function validateDataUpdateUser(paramUserObj) {
        if (paramUserObj.fullName == "") {
            alert("Please input fullname");
            return false;
        }
        if (paramUserObj.phone == "") {
            alert("Please input phone");
            return false;
        }
        return true
    }
    //hàm gọi API để update user:
    function callApiToUpdateUserById(paramUserObj) {
        $.ajax({
            url: gBASE_URL + gUserId,
            type: "PUT",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramUserObj),
            success: function (paramRes) {
                handleUpdateUserSuccess()
            },
            error: function (paramErorr) {
                console.log(paramErorr.responseText)
            }
        });
    }
    //hàm handle khi update user thành công:
    function handleUpdateUserSuccess() {
        alert("Update user successfully");
        resertUpdateUserForm();
        $("#update-user-modal").modal("hide");
        getUserList()
    }
    //hàm xóa trắng form insert user:
    function resertUpdateUserForm() {
        $("#input-update-user-fullname").val("");
        $("#input-update-user-phone").val("");
        $("#select-update-user-status").val("Level 0");
    }

    //các hàm xử lý delete user:
    //hàm gọi API để delete user:
    function callApiToDeleteUserById(paramUserIdObj) {
        $.ajax({
            url: gBASE_URL + paramUserIdObj,
            type: "DELETE",
            success: function (paramRes) {
                handleDeleteUserSuccess()
            },
            error: function (paramErorr) {
                console.log(paramErorr.responseText)
            }
        });
    }
    //hàm handle khi delete user thành công:
    function handleDeleteUserSuccess() {
        alert("Delete user successfully");
        $("#delete-confirm-modal").modal("hide");
        getUserList()
    }


</script>

</html>